<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_8</title>
</head>
<body>
    <h1>Capitulo 8</h1>
    <a>Ejercicio 4</a>

    <script>   

        const busquedaSubcon = (sub, num, output, index) => {

            if (index === num.length) {
                sub.push(output);
                return;
            }

            busquedaSubcon(sub, num, [...output], index + 1);
            output.push(num[index]);
            busquedaSubcon(sub, num, [...output], index + 1)
        }
 
        let sub = [],
          input = [];
        input.push(1);
        input.push(2);
        input.push(3);

        busquedaSubcon(sub, input, [], 0);

        sub.sort((o1, o2) => {
            let n = Math.min(o1.length, o2.length);
            
            for (var i = 0; i < n; i++) {
                if(o1[i] === o2[i]) {
                    continue;
                } else {
                    return o1[i] - o2[i];
                }
            }
            return 1;
        });

        for (var i = 0; i < sub.length; i++) {
            for (var j = 0; j < sub[i].length; j++) {
                document.write(sub[i][j]);
            }
            document.write("<br>")
        }

        
</script>
    
</body>
</html>